<?php
// $Id: modinfo.php,v 1.13.2.1 2004/06/04 10:33:35 mithyt2 Exp $
// Module Info

// The name of this module
define('_MI_NEWS_NAME','News');

// A brief description of this module
define('_MI_NEWS_DESC','Creates a Slashdot-like news section, where users can post news/comments.');

// Names of blocks for this module (Not all module has blocks)
define('_MI_NEWS_BNAME1','News Topics');
define('_MI_NEWS_BNAME3','Big Story');
define('_MI_NEWS_BNAME4','Top News');
define('_MI_NEWS_BNAME5','Recent News');
define('_MI_NEWS_BNAME6','Moderate News');
define('_MI_NEWS_BNAME7','Navigate thru topics');
define('_MI_NEWS_BNAME8','Recent articles in a topic');

// Sub menus in main menu block
define('_MI_NEWS_SMNAME1','Submit News');
define('_MI_NEWS_SMNAME2','Archive');

// Names of admin menu items
define('_MI_NEWS_ADMENU2', 'Topics Manager');
define('_MI_NEWS_ADMENU3', 'Post/Edit News');
define('_MI_NEWS_GROUPPERMS', 'Submit/Approve Permissions');

// Title of config items
define('_MI_STORYHOME', 'Select the number of news items to display on top page');
define('_MI_NOTIFYSUBMIT', 'Select yes to send notification message to webmaster upon new submission');
define('_MI_DISPLAYNAV', 'Select yes to display navigation box at the top of each news page');
define('_MI_ANONPOST','Allow anonymous users to post news articles?');
define('_MI_AUTOAPPROVE','Auto approve news stories without admin intervention?');
define("_MI_ALLOWEDSUBMITGROUPS", "Groups who can Submit News");
define("_MI_ALLOWEDAPPROVEGROUPS", "Groups who can Approve News");
define("_MI_NEWSDISPLAY", "News Display Layout");
define("_MI_NAMEDISPLAY","Author's name");
define("_MI_COLUMNMODE","Columns");
define("_MI_STORYCOUNTADMIN","Number of new articles to display in admin area: ");
define('_MI_UPLOADFILESIZE', 'MAX Filesize Upload (KB) 1048576 = 1 Meg');
define("_MI_UPLOADGROUPS","Authorized groups to upload");


// Description of each config items
define('_MI_STORYHOMEDSC', '');
define('_MI_NOTIFYSUBMITDSC', '');
define('_MI_DISPLAYNAVDSC', '');
define('_MI_AUTOAPPROVEDSC', '');
define("_MI_ALLOWEDSUBMITGROUPSDESC", "The selected groups will be able to submit news items");
define("_MI_ALLOWEDAPPROVEGROUPSDESC", "The selected groups will be able to approve news items");
define("_MI_NEWSDISPLAYDESC", "Classic shows all news ordered by date of publish. News by topic will group the news by topic with the latest story in full and the others with just the title");
define('_MI_ADISPLAYNAMEDSC', 'Select how to display the author\'s name');
define("_MI_COLUMNMODE_DESC","You can choose the number of columns to display articles list");
define("_MI_STORYCOUNTADMIN_DESC","");
define("_MI_UPLOADFILESIZE_DESC","");
define("_MI_UPLOADGROUPS_DESC","Select the groups who can upload to the server");

// Name of config item values
define("_MI_NEWSCLASSIC", "Classic");
define("_MI_NEWSBYTOPIC", "By Topic");
define("_MI_DISPLAYNAME1", "Username");
define("_MI_DISPLAYNAME2", "Real Name");
define("_MI_DISPLAYNAME3", "Do not display author");
define("_MI_UPLOAD_GROUP1","Submitters and Approvers");
define("_MI_UPLOAD_GROUP2","Approvers Only");
define("_MI_UPLOAD_GROUP3","Upload Disabled");

// Text for notifications

define('_MI_NEWS_GLOBAL_NOTIFY', 'Global');
define('_MI_NEWS_GLOBAL_NOTIFYDSC', 'Global news notification options.');

define('_MI_NEWS_STORY_NOTIFY', 'Story');
define('_MI_NEWS_STORY_NOTIFYDSC', 'Notification options that apply to the current story.');

define('_MI_NEWS_GLOBAL_NEWCATEGORY_NOTIFY', 'New Topic');
define('_MI_NEWS_GLOBAL_NEWCATEGORY_NOTIFYCAP', 'Notify me when a new topic is created.');
define('_MI_NEWS_GLOBAL_NEWCATEGORY_NOTIFYDSC', 'Receive notification when a new topic is created.');
define('_MI_NEWS_GLOBAL_NEWCATEGORY_NOTIFYSBJ', '[{X_SITENAME}] {X_MODULE} auto-notify : New news topic');

define('_MI_NEWS_GLOBAL_STORYSUBMIT_NOTIFY', 'New Story Submitted');
define('_MI_NEWS_GLOBAL_STORYSUBMIT_NOTIFYCAP', 'Notify me when any new story is submitted (awaiting approval).');
define('_MI_NEWS_GLOBAL_STORYSUBMIT_NOTIFYDSC', 'Receive notification when any new story is submitted (awaiting approval).');
define('_MI_NEWS_GLOBAL_STORYSUBMIT_NOTIFYSBJ', '[{X_SITENAME}] {X_MODULE} auto-notify : New news story submitted');

define('_MI_NEWS_GLOBAL_NEWSTORY_NOTIFY', 'New Story');
define('_MI_NEWS_GLOBAL_NEWSTORY_NOTIFYCAP', 'Notify me when any new story is posted.');
define('_MI_NEWS_GLOBAL_NEWSTORY_NOTIFYDSC', 'Receive notification when any new story is posted.');
define('_MI_NEWS_GLOBAL_NEWSTORY_NOTIFYSBJ', '[{X_SITENAME}] {X_MODULE} auto-notify : New news story');

define('_MI_NEWS_STORY_APPROVE_NOTIFY', 'Story Approved');
define('_MI_NEWS_STORY_APPROVE_NOTIFYCAP', 'Notify me when this story is approved.');
define('_MI_NEWS_STORY_APPROVE_NOTIFYDSC', 'Receive notification when this story is approved.');
define('_MI_NEWS_STORY_APPROVE_NOTIFYSBJ', '[{X_SITENAME}] {X_MODULE} auto-notify : Story approved');

define('_MI_RESTRICTINDEX', 'Restrict Topics on Index Page?');
define('_MI_RESTRICTINDEXDSC', 'If set to yes, users will only see news items listed in the index from the topics, they have access to as set in News Permissions');
?>